<?php

/**
*
* @copyright (c) 2011 Laf Innovative, Ltd.
* @license http://www.opensource.org/licenses/mit-license.php MIT License
* 
*/

?>

	<div id="functions">
		<a href="index.php?adp=import&amp;action=main">Main</a> &nbsp; | &nbsp; 
		<a href="index.php?adp=import&amp;action=dmoz">DMOZ</a>
	</div>

<?php

switch ($action) {
    case "main":
?> Importing links from other places can be fun, easy, and the fastest way to populate your directory with useful content.<br> Please be aware that URLs alone are not copyrighted, while collection of links <a target="_blank" href="http://en.wikipedia.org/wiki/Intellectual_property">is an Intellectual property</a> and can be protected by copyright laws.<p> <li><a target="_blank" href="http://dmoz.org/license.html">Open Directory License</a> <p> Importing DMOZ category structure is not available for one big reason. Google, Yahoo, as well as other search engines are banning web sites that have DMOZ category structure. It is much better to make your own unique category structure and then import some links. <p> <?php
	break;
    case "dmoz":
        $url = "http://www.dmoz.org/" . $path;
        if (strlen($path) > 0 & strpos($path, ".html") === false) {
            $url .= "/";
        }
        $file         = fetchURL($url);
        $n_blocks     = "";
        $n_categories = "";
        $n_pages      = "";
        $n_bar        = "";
        $odp          = array();
        if (!$path) {
            $n_blocks += 1;
            $n_categories += 1;
            $odp["categories"][$n_blocks][$n_categories]["category"] = "Adult";
            $odp["categories"][$n_blocks][$n_categories]["path"]     = "/Adult/";
            while (preg_match('/<b><a href="([^"]+)">([^\n]+)<\/a><\/b>/', $file, $out)) {
                $n_categories += 1;
                $odp["categories"][$n_blocks][$n_categories]["category"] = $out[2];
                $odp["categories"][$n_blocks][$n_categories]["path"]     = $out[1];
                $file                                                    = substr($file, strpos($file, $out[0]) + strlen($out[0]));
            }
        } else {
            /* while (preg_match('/<a href="([^"]+)"><b>([^<]+)<\/b><\/a>/', $file, $out)) {
                $n_bar += 1;
                $odp["bar"][$n_bar]["category"] = $out[2];
                $odp["bar"][$n_bar]["path"]     = $out[1];
                $file                           = substr($file, strpos($file, $out[0]) + strlen($out[0]));
            } */
            while(preg_match('/<a href="([^"]+)"><b>([^<]+)<\/b><\/a>@?\n &nbsp;<i>\(([^.\)]+)\)<\/i>/', $file, $out)) {
                $crossed = false;
                if (!strpos($out[5], "@") === false)
                    $crossed = "@";
                if (strpos($file, $out[0]) > strpos($file, "<hr>")) {
                    $n_blocks += 1;
                    $n_categories = 0;
                }
                if (isset($c_title_array[0]) != "Adult" || $out[5] != "World") {
                    $n_categories += 1;
                    $odp["categories"][$n_blocks][$n_categories]["category"] = $out[2];
                    $odp["categories"][$n_blocks][$n_categories]["path"]     = $out[1];
                    $odp["categories"][$n_blocks][$n_categories]["pages"]    = $out[3];
                    if ($crossed)
                        $odp["categories"][$n_blocks][$n_categories]["crossed"] = $crossed;
                }
                $file = substr($file, strpos($file, $out[0]) + strlen($out[0]));
            }
            include('pagerank.php');
            $oPR = new GooglePR();
            while (preg_match('/<li><a href="([^"]+)">([^<]+)<\/a> - ([^\n]+)/', $file, $out)) {
                $n_pages += 1;
                $odp["pages"][$n_pages]["url"]         = $out[1];
                $odp["pages"][$n_pages]["title"]       = $out[2];
                $odp["pages"][$n_pages]["description"] = $out[3];
                $odp["pages"][$n_pages]["gpr"]         = $oPR->GetPR($out[1]);
                $file                                  = substr($file, strpos($file, $out[0]) + strlen($out[0]));
            }
        }
        if ($path) {
            print "<a href=\"index.php?adp=import&action=dmoz\">Top</a> ";
            $parts = explode('/', trim($path, '/'));
            if (count($parts)) {
                for ($i = 0; $i < count($parts); $i++) {
                    $url = '';
                    for ($j = 0; $j <= $i; $j++) {
                        $url .= '/' . $parts[$j];
                    }
                    $url .= '/';
                    $loc = str_replace("_", " ", $parts[$i]);
                    print " > <a href=\"index.php?adp=import&action=dmoz&path=$url\">$loc</a>";
                }
                print " <a target=\"_blank\" href=\"http://dmoz.org$url\"><img border=\"0\" src=\"images/nw2.png\"></a>";
            }
        }
        if (isset($odp["bar"])) {
            print "<hr><img src=\"/images/folder.gif\"> ";
            for ($a = 1; $a <= count($odp["bar"]); $a++) {
                print "<a href=\"index.php?adp=import&action=dmoz&path=" . $odp["bar"][$a]["path"] . "\">" . $odp["bar"][$a]["category"] . "</a> ";
            }
            print "<p>";
        }
        if (isset($odp["categories"])) {
            for ($a = 1; $a <= count($odp["categories"]); $a++) {
                if ($path) {
?><hr><?php                }
?><table border="0" cellpadding="0" cellspacing="0"><tr><td valign="top"><font size="2"><?php                for ($b = 1; $b <= count($odp["categories"][$a]); $b++) {
                    if (isset($odp["categories"][$a][$b]["crossed"])) {
                        $crossed = "@";
                    } else {
                        $crossed = "";
                    }
                    if (isset($odp["categories"][$a][$b]["pages"])) {
                        $pages = $odp["categories"][$a][$b]["pages"];
                    } else {
                        $pages = 0;
                    }
                    print "<img src=\"/images/folder.gif\"> <a href=\"index.php?adp=import&action=dmoz&path=" . $odp["categories"][$a][$b]["path"] . "\">" . $odp["categories"][$a][$b]["category"] . "</a>$crossed (" . $pages . ") <a target=\"_blank\" href=\"http://dmoz.org" . $odp["categories"][$a][$b]["path"] . "\"><img border=\"0\" src=\"images/nw2.png\"></a><br>";
                    if ($b == ceil(count($odp["categories"][$a]) / 2)) {
?></td><td width="30">&nbsp;</td><td valign="top"><font size="2"><?php                    }
                }
?></td></tr></table><?php            }
        }
        if (isset($odp["pages"])) {
            print "<br>&nbsp;";
            usort($odp["pages"], "cmp");
?><form action="index.php" method="POST"><input type="hidden" name="adp" value="import"><input type="hidden" name="action" value="dmoz_add"><table cellpadding="0" cellspacing="0" width="100%" border="0" bgcolor="#CCCCCC"><tr bgcolor="green"><td><img width="1" height="1" src="images/pixel.png"></td></tr><tr><td>&nbsp;<input type="submit" value="Add to:"><select name="category"><?php            list_cats(0, 0, 0, 0);
?></select></td></tr><tr bgcolor="green"><td><img width="1" height="1" src="images/pixel.png"></td></tr><?php            if (cfg("admin_dmoz_check") == "1") {
                $checked = "checked";
            } else {
                $checked = "";
            }
            for ($a = 0; $a <= count($odp["pages"]) - 1; $a++) {
                if ($odp["pages"][$a]["gpr"] >= cfg("admin_gpr")) {
                    print "<tr bgcolor=\"#E1E1E1\"><td><font size=\"2\">&nbsp;<input $checked name=\"list[" . $a . "]\" type=\"checkbox\"> <input type=\"hidden\" name=\"gpr[" . $a . "]\" value=\"" . $odp["pages"][$a]["gpr"] . "\">PR:" . $odp["pages"][$a]["gpr"] . " <a target=\"_blank\" href=\"" . $odp["pages"][$a]["url"] . "\"><font color=\"green\">" . $odp["pages"][$a]["url"] . "</font></a></td></tr>\n";
                    print "<tr bgcolor=\"#F1F1F1\" onMouseOver=\"this.bgColor='#F9F9F9';\" onMouseOut=\"this.bgColor='#F1F1F1';\"><td>";
                    print "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td align=\"right\"><font size=\"1\">URL:</td><td><font size=\"2\"><input type=\"text\" size=\"90\" name=\"url[" . $a . "]\" value=\"" . $odp["pages"][$a]["url"] . "\"></td></tr>\n";
                    print "<tr><td align=\"right\"><font size=\"1\">Title:</td><td><input type=\"text\" size=\"90\" name=\"title[" . $a . "]\" value=\"" . $odp["pages"][$a]["title"] . "\"></td></tr>\n";
                    print "<tr><td><font size=\"1\">Desc:</td><td><textarea cols=\"70\" rows=\"4\" name=\"description[" . $a . "]\">" . $odp["pages"][$a]["description"] . "</textarea><br>&nbsp;</td></tr></table></td></tr>\n";
                    print "<tr bgcolor=\"green\"><td><img width=\"1\" height=\"1\" src=\"images/pixel.png\"></td></tr>\n";
                }
            }
?> <tr><td><font size="1">&nbsp;</td></tr><tr bgcolor="green"><td><img width="1" height="1" src="images/pixel.png"></td></tr></table></form> <?php        }
        break;
    case "dmoz_add":
        if (ADP_DEMO == "1") {
            print "DISABLED IN DEMO MODE";
        } else {
?><b>WARNING!</b> - refreshing or reloading this page will add the same links twice to the same category, resulting in multiple dupe submissions!<br> Click [Back] button in your web browser to go back to DMOZ import!<p> Adding new links....<hr><?php            $b = 0;
            for ($a = 0; $a <= count($_REQUEST['list']) + 3; $a++) {
                if (isset($_REQUEST['list'][$a]) == "on") {
                    $arr[$b]['category']    = $_REQUEST['category'];
                    $arr[$b]['url']         = $_REQUEST['url'][$a];
                    $arr[$b]['title']       = $_REQUEST['title'][$a];
                    $arr[$b]['description'] = $_REQUEST['description'][$a];
                    $arr[$b]['gpr']         = $_REQUEST['gpr'][$a];
                    $b++;
                    insert_link($_REQUEST['url'][$a], $_REQUEST['title'][$a], $_REQUEST['description'][$a], $_REQUEST['category'], "1", $_REQUEST['gpr'][$a], "");
                    print "<li>Added: " . $_REQUEST['url'][$a] . "<br>\n";
                }
            }
        }
        break;
}
?>